% Taha Babaei
 % darajate azadi ra baraye kharpa be in surat darnazar begirid k az gerehye 1 shoru konid va be garehye payani beresid.ya'ni daraje azadiye ofaghiye gerehye 1 ra U1 va gha'emash ra U2 va daraje azadiye ofoghiye gerehye 2 ra U3 va gha'emash ra U4 va baraye gerehye 3 niz betartib ofoghi va gha'em ra U5 va U6 va ela akhar ta be akharin gereh beresin.ra'ayate in namgozari ELZAMI ast zira matrixe sakhti bar asase in namgozariye gereha darnazar gerefte shode ast.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                
clear all;clc;close all;%pak kardane tamame moteghayerha va panjereye dasturat va bastane panjerehaye baze dige.
format short%deghghate namayeshe a'dad ra ta 4 ragham ba'd az a'shar mikonad.(baraye inke deghghate namayeshe a'dad ta 15 raghame a'shar afzayesh yabad bejaye kalameye 'short' kalameye 'long' ra vared konid.
disp '"Welcome"';
pause(4);
disp '"Thank you for using this program to analysis your 2D Truss by Finite Element Method"';
pause(5);
disp '"This Program Is Writed By TAHA BABAEI"';
disp('please wait ...')
disp(' ')
pause(7);
TRUSSINPUTES=xlsread('TRUSS.xlsx');%baz kardane file e excel e mojud dar pusheye barname jahate khandane ettela'ate mas'ale.
ElementNum=TRUSSINPUTES(1,1);%khandane te'dade elemanha az file e excele fogh
NodeNum=TRUSSINPUTES(1,2);%
U0Num=TRUSSINPUTES(1,3);%khandane te'dade darajate azadiye basteh(darajate azadiye gheyre fa'al ya be ebarati digar haman darajate azadiye sefr k haman aksol'amalhaye tekyegahi hastand)
EMatrix=TRUSSINPUTES(1:ElementNum,4);%khandane matrixe zarayebe elasticity az file e excel
AMatrix=TRUSSINPUTES(1:ElementNum,5);%khandane matrixe sathe maghta' az file e excel
ElementNodes=TRUSSINPUTES(1:ElementNum,8:9);%khandane matrixe namgozariye har eleman(gerehye ebteda va gerehye entehaye har eleman) az file e excel
NodeCoordinates=TRUSSINPUTES(1:NodeNum,10:11);%khandane matrixe mokhtasate har gereh az file e excel
xx=NodeCoordinates(:,1);%sotune avval az matrixe NodeCoordinates(X ha)
yy=NodeCoordinates(:,2);%sotune dovvom az matrixe NodeCoordinates(Y ha)
AllDof=2*NodeNum;%te'dade kolle darajate azadi(zaribe 2 be in dalil ast k be ezaye har gereh 2 ta darajeye azadi darim)
U=zeros(AllDof,1);
force=zeros(AllDof,1);
force=TRUSSINPUTES(1:AllDof,6);%khandane matrixe bargozari az file e excel
DeactivedDof=TRUSSINPUTES(1:U0Num,7);%khandane matrixe shomareye darajate azadiye gheyre fa'al az file e excel
%Matrixe Sakhti(Stiffness Matrix)
stiffness=zeros(AllDof);
for e=1:ElementNum%in halghe matrixe sakhtiye har eleman ra besurate jodagane mohasebe mikonad.(meghdare 'e' az 1 ta te'dade elemanha dar har charkheshe halghe namayandeye shomareye elemani ast k matrixe sakhtiash bayad mohasebe shavad)
    E=EMatrix(e);%derayeye 'e' om az matrixe [EMatrix] k haman zaribe elasticity baraye elemane 'e' om mibashad.
    A=AMatrix(e);%derayeye 'e' om az matrixe [AMatrix] k haman sathe maghta'e elemane 'e' om mibashad.
    EA=E*A;%sakhtiye mehvariye har eleman
    ElementCourse=ElementNodes(e,:);%ElementCourse=ebteda va entehaye eleman(gerehye ebteda va gerehye entehaiye eleman).(jahate har eleman az gerehye ebteda be gerehye enteha)(satre 'e' om az matrixe ElementNodes)
    ElementDof=[[2*ElementNodes(e,1)-1] [2*ElementNodes(e,1)] [2*ElementNodes(e,2)-1] [2*ElementNodes(e,2)]];
    xa=xx(ElementCourse(2))-xx(ElementCourse(1));%mohasebeye andazeye mo'alefeye ofoghiye har eleman
    ya=yy(ElementCourse(2))-yy(ElementCourse(1));%mohasebeye andazeye mo'alefeye gha'eme har eleman
    length_element=sqrt(xa*xa+ya*ya);%mohasebeye andazeye har eleman ba estefade az ghaziyeye fisaghores
    cosinus=xa/length_element;
    sinus=ya/length_element;
    ll=length_element;
    tetta=atan(ya/xa);
    k=(EA/ll)*[cosinus^2,0.5*sin(2*tetta),-cosinus^2,-0.5*sin(2*tetta);0.5*sin(2*tetta),sinus^2,-0.5*sin(2*tetta),-sinus^2;-cosinus^2,-0.5*sin(2*tetta),cosinus^2,0.5*sin(2*tetta);-0.5*sin(2*tetta),-sinus^2,0.5*sin(2*tetta),sinus^2];%k:matrixe sakhtiye har eleman.{khode in matrixe [k] ra ba ta'sire matrixe tabdil neveshteam va baraye mohasebeye matrixe sakhtiye kolle sazeh niazi be ta'sir dadane matrixe tabdil(masalan T) besurate(k=T'*k*T)ruye matrixe sakhtiye har eleman [k] nist}
    stiffness(ElementDof,ElementDof)=stiffness(ElementDof,ElementDof)+k;%stiffness:matrixe sakhtiye kolle sazeh k da har charkheshe halghe kameltar va dar akharin charkheshe halghe baraye akharin eleman be kameltarin shekle khod k haman matrixe sakhtiye kolle sazeh ast tabdil mishavad.
Ke(1:4,e*4-3:e*4)=k;%Ke:matrixe Makhzan.(matrixi ke matrixhaye sakhtiye tamame elemanha ra dar khod zakhire mikonad ta ba'dan betunim azashun estefade konim)
end
%mohasebeye Displacements (jabejaihaye har gereh) va namayeshe khorujiha
activeDof=setdiff([1:AllDof]', [DeactivedDof]);%setdiff(A,B):anasori az bordare([matrixe] ya {majmueye}) A ra ke dar bordare B vojud nadarand neshan midahad.(az kolle darajate azadi anhai k 0 mishavand (prescribedDof) ra kam mikonad va darajate azadiye gheyre sefr ra neshan midahad(moshakhas mikonad)
U=stiffness(activeDof,activeDof)\force(activeDof);%bedast avardane matrixe jabejaiye kolle sazehbaraye darajate azadiye fa'al (U)
Displacements=zeros(AllDof,1);
Displacements(activeDof)=U;
%mohasebeye Reactions (aksol'amalhaye tekyegahi) va namayeshe khorujiha
disp('***Displacement***')
NNode=1:AllDof;
[NNode' Displacements]%in matrix tarkibi az 2 matrixe Displacements va taranahadeye matrixe NNode ast k dar moghabele shomareye har gereh mizane jabejaiash ra namayesh midahad.
F=stiffness*Displacements;%F=KU
reactions=F(DeactivedDof);
disp('***Reactions***')
[DeactivedDof reactions]
%mohasebeye Internal Forces (niruhaye dakheliye har eleman) va namayeshe khorujiha                                                                                                                                                                                                                        
for p=1:ElementNum%in halghe baraye mohasebeye matrixe jabejaiye har eleman mibashad
    Ut=Displacements;
    u1=Ut(2*ElementNodes(p,1)-1);%jabejaiye ofoghi ruye gerehye ebtedaye har eleman
    u2=Ut(2*ElementNodes(p,1));%jabejaiye ofoghi ruye gerehye entehaye har eleman
    u3=Ut(2*ElementNodes(p,2)-1);%jabejaiye ghaem ruye gerehye ebtedaye har eleman
    u4=Ut(2*ElementNodes(p,2));%jabejaiye ghaem ruye gerehye entehaye har eleman
    disp('Internal Force,Stiffness and Displacement Matrix For Element');disp(p)
    ue=[u1;u2;u3;u4]%matrixe jabejaiye gerehaye har eleman
    ke=Ke(1:4,p*4-3:p*4)%matrixe har eleman [ke] ra az matrixe Makhzan [Ke] estekhraj mikonim.
    fe=ke*ue%matrixe niruhaye dakheliye har eleman
    disp('- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -')
end
disp('A N A L Y S I S   C O M P L E T E ')
disp(datestr(clock))
save('Truss Displacements.txt','Displacements','-ascii');%dasture zakhireye Displacements dar file e txt.
save('Truss Reactions.txt','reactions','-ascii');%dasture zakhireye Reactions dar file e txt.
